// ignore_for_file: use_build_context_synchronously
import 'dart:convert';
import 'package:provider/provider.dart';
import '../Forma_viewModel/Forma_view_model_screen.dart';
import '../../../../utils/image_constant.dart';
import '../../../../utils/size_utils.dart';
import '../../../../theme/app_style.dart';
import '../../../../widgets/app_bar/appbar_image.dart';
import '../../../../widgets/app_bar/appbar_title.dart';
import '../../../../widgets/app_bar/custom_app_bar.dart';
import 'package:barcode_widget/barcode_widget.dart';
import 'package:fluttertoast/fluttertoast.dart';
import '../../../../widgets/custom_button.dart';
import '../../../../widgets/custom_text_form_field.dart';
import 'package:flutter/material.dart';
import 'package:autocomplete_textfield/autocomplete_textfield.dart';
import 'package:qr_flutter/qr_flutter.dart';
import 'package:intl/intl.dart';

import 'dart:math';
import '../../../../Reuseable/reusable_text_field.dart';
import '../../../../Reuseable/reusable_date_picker_field.dart';
import '../../../../Reuseable/reusable_date_time_picker_field.dart';
import 'package:flutter/services.dart';
class formaUpdateEntityScreen extends StatefulWidget {
    final Map<String, dynamic> entity;


  formaUpdateEntityScreen({required this.entity});

  @override
  _formaUpdateEntityScreenState createState() => _formaUpdateEntityScreenState();
}

class _formaUpdateEntityScreenState extends State<formaUpdateEntityScreen> {
  final _formKey = GlobalKey<FormState>();










  bool _passwordVisiblepassword_field = false;
  bool _isPasswordValidpassword_field = true;
  bool _doPasswordsMatchpassword_field = true;

  String _passwordpassword_field = ''; // To store the first password

  void _validatePasswordpassword_field(String password) {
    setState(() {
      _isPasswordValidpassword_field = password.isNotEmpty;
      _passwordpassword_field = password; // Store the password for later comparison
      _doPasswordsMatchpassword_field = true; // Reset match flag on new input
    });
  }

  void _validateConfirmPasswordpassword_field(String confirmPassword) {
    setState(() {
      _doPasswordsMatchpassword_field = confirmPassword == _passwordpassword_field;
    });
  }



TextEditingController date_field = TextEditingController(); 
DateTime selectedDatedate_field = DateTime.now();

Future<void> _selectDatedate_field(BuildContext context) async {
  final DateTime? picked = await showDatePicker(
    context: context,
    initialDate: selectedDatedate_field,
    firstDate: DateTime(2000),
    lastDate: DateTime(2101),
  );
  print(picked);
  if (picked != null && picked != selectedDatedate_field) {
    setState(() {
      selectedDatedate_field = picked;
    });
  }
}

DateTime selectedDateTimedatetime_field = DateTime.now();
TextEditingController datetime_field = TextEditingController();
Future<void> _selectDateTimedatetime_field(BuildContext context) async {
  final DateTime? picked = await showDatePicker(
    context: context,
    initialDate: selectedDateTimedatetime_field,
    firstDate: DateTime(2000),
    lastDate: DateTime(2101),
  );

  if (picked != null) {
    final TimeOfDay? pickedTime = await showTimePicker(
      context: context,
      initialTime: TimeOfDay.fromDateTime(selectedDateTimedatetime_field),
    );
    print(pickedTime);
    if (pickedTime != null) {
      setState(() {
        selectedDateTimedatetime_field = DateTime(
          picked.year,
          picked.month,
          picked.day,
          pickedTime.hour,
          pickedTime.minute,
        );
      });
    }
  }
}

bool _isemail_fieldEmailValid = true;

void _validateemail_fieldEmail(String email) {
  setState(() {
    _isemail_fieldEmailValid = RegExp(r'^[\\w-]+(\\.[\\w-]+)*@[\\w-]+(\\.[\\w-]+)+$').hasMatch(email);
  });
}

  bool istoggle_switch = false;

bool _isUrlValidurl_field = true;

void _validateUrlurl_field(String url) {
  setState(() {
    _isUrlValidurl_field= Uri.parse(url).isAbsolute;
  });
}


  @override
  void initState() {
    super.initState();


















istoggle_switch = widget.entity['toggle_switch'] ?? false; // Set initial value



}

 
  @override
  Widget build(BuildContext context) {
    return Scaffold(
      appBar: CustomAppBar(
          height: getVerticalSize(49),
          leadingWidth: 40,
          leading: AppbarImage(
              height: getSize(24),
              width: getSize(24),
              svgPath: ImageConstant.imgArrowleftBlueGray900,
              margin: getMargin(left: 16, top: 12, bottom: 13),
              onTap: () {
                Navigator.pop(context);
              }),
          centerTitle: true,
          title: AppbarTitle(text: "Update Forma"),        actions: [






















        ],
),
      body: Consumer<FormaViewModelScreen>(builder: (context, value, child) {
          return SingleChildScrollView(
        child: Padding(
          padding: const EdgeInsets.all(16),
          child: Form(
            key: _formKey,
            child: Column(
              children: [
 
                        ReusableTextField(
                           
                            label: "Please Enter Text Field",
                            initialValue: widget.entity['text_field'] ?? '',

   // ValidationProperties
                            onSaved: (value) => widget.entity['text_field'] = value,
),
                    
                          SizedBox(height: 16),


 ReusableTextField(
              initialValue: widget.entity['number_field'].toString(),
              onSaved: (value) => widget.entity['number_field']= value,
              label: "Enter Number Field",
              keyboardType: TextInputType.number,
              inputFormatters: [
                FilteringTextInputFormatter.allow((RegExp(r'[0-9]'))),
              ],
              validator: (value) {
                if (value == null || value.isEmpty) {
                  return 'Please enter a number';
                }
                return null;
              },
            ),

ReusableTextField(
              initialValue: widget.entity['phone_number'],
              onSaved: (value) => widget.entity['phone_number'] = value,
              label: "Enter Phone Number",
              keyboardType: TextInputType.number,
              inputFormatters: [
                FilteringTextInputFormatter.digitsOnly,
 LengthLimitingTextInputFormatter(
                        10), // Limit input to 10 digits
              ],
              validator: (value) {
                if (value == null || value.isEmpty) {
                  return 'Please enter  Phone Number';
                }
                if (value.length != 10) {
                      return 'Phone number must be exactly 10 digits';
                    }
                    return null;
              },
            ),

 // }),
            ReusableTextField(
              initialValue: widget.entity['paragraph_field'],
              onSaved: (value) =>  widget.entity['paragraph_field']= value,
              label: "Enter Paragraph Field",
              maxLines: 5,
            ),

TextFormField(
              initialValue: widget.entity['password_field'],

                  obscureText: !_passwordVisiblepassword_field,
                  decoration: InputDecoration(
                    labelText: 'Password Field',
                    suffixIcon: IconButton(
                      icon: Icon(
                        _passwordVisiblepassword_field
                            ? Icons.visibility
                            : Icons.visibility_off,
                      ),
                      onPressed: () {
                        setState(() {
                          _passwordVisiblepassword_field = !_passwordVisiblepassword_field;
                        });
                      },
                    ),
                    errorText:
                        _isPasswordValidpassword_field ? null : 'Please enter a password',
                    border: OutlineInputBorder(),
                  ),
                  onSaved: (value) => widget.entity['password_field'] = value,
                  onChanged: _validatePasswordpassword_field,
                ),
                const SizedBox(height: 16),
                TextFormField(
                  obscureText: !_passwordVisiblepassword_field,
                  decoration: InputDecoration(
                    labelText: 'Confirm Password Field',
                    suffixIcon: IconButton(
                      icon: Icon(
                        _passwordVisiblepassword_field
                            ? Icons.visibility
                            : Icons.visibility_off,
                      ),
                      onPressed: () {
                        setState(() {
                          _passwordVisiblepassword_field = !_passwordVisiblepassword_field;
                        });
                      },
                    ),
                    errorText:
                        _doPasswordsMatchpassword_field ? null : 'Passwords do not match',
                    border: OutlineInputBorder(),
                  ),
                  onChanged: _validateConfirmPasswordpassword_field,
                ),





            ReusableTextField(
              initialValue: widget.entity['textarea'],
              onSaved: (value) => widget.entity['textarea']= value,
              label: "Enter Textarea",
              maxLines: 5,
            ),

 ReusableDatePickerField(label: 'Date Field', controller: date_field, initialDate: widget.entity['date_field'],
                                      onSaved: (value) => widget.entity['date_field'] = value,),


 ReusableDateTimePickerField(label:'Datetime Field', controller: datetime_field, initialDateTime:widget.entity['datetime_field'] ,
                                      onSaved: (value) => widget.entity['datetime_field'] = value,),


  Padding(
                    padding: getPadding(top: 19),
                    child: Column(
                        crossAxisAlignment: CrossAxisAlignment.start,
                        mainAxisAlignment: MainAxisAlignment.start,
                        children: [
                          Text("Email Field",
                              overflow: TextOverflow.ellipsis,
                              textAlign: TextAlign.left,
                              style: AppStyle
                                  .txtGilroyMedium16Bluegray900),
                          CustomTextFormField(
                              hintText: "Enter Email Field",
                              initialValue: widget.entity['email_field'],
                               keyboardType: TextInputType.url,
                              errorText: _isemail_fieldEmailValid ? null : 'Please enter a valid URL',
                                onChanged: _validateemail_fieldEmail,



   // ValidationProperties

                              onsaved: (value) {
                                widget.entity['email_field'] = value;
                              },
                              margin: getMargin(top: 6))
                        ])),

SizedBox(height: 16),

Row(
  children: [
    Switch(
      value: istoggle_switch,
      onChanged: (newValue) {
        setState(() {
          istoggle_switch = newValue;
        });
      },
  activeColor: Colors.white,
              activeTrackColor: Colors.green,
              inactiveThumbColor: Colors.white,
              inactiveTrackColor: Colors.red,
    ),
    const SizedBox(width: 8),
    const Text('Toggle Switch'),
  ],
),

  Padding(
                    padding: getPadding(top: 19),
                    child: Column(
                        crossAxisAlignment: CrossAxisAlignment.start,
                        mainAxisAlignment: MainAxisAlignment.start,
                        children: [
                          Text("Url Field",
                              overflow: TextOverflow.ellipsis,
                              textAlign: TextAlign.left,
                              style: AppStyle
                                  .txtGilroyMedium16Bluegray900),
                          CustomTextFormField(
                              hintText: "Enter Url Field",
                              initialValue: widget.entity['url_field'],
                               keyboardType: TextInputType.url,
                              errorText: _isUrlValidurl_field ? null : 'Please enter a valid URL',
                                onChanged: _validateUrlurl_field,



   // ValidationProperties

                              onsaved: (value) {
                                widget.entity['url_field'] = value;
                              },
                              margin: getMargin(top: 6))
                        ])),

SizedBox(height: 16),

 
          CustomButton(
                  height: getVerticalSize(50),
                  text: "Update",
                  margin: getMargin(top: 24, bottom: 5),
                  onTap: () async {
                    if (_formKey.currentState!.validate()) {
                      _formKey.currentState!.save();


















widget.entity['toggle_switch'] = istoggle_switch;



       
                        try {
                        await value.updateEntity(
                              widget.entity[
                                  'id'], // Assuming 'id' is the key in your entity map
                              widget.entity);   























                        Navigator.pop(context);
                      } catch (e) {
                        // ignore: use_build_context_synchronously
                        showDialog(
                          context: context,
                          builder: (BuildContext context) {
                            return AlertDialog(
                              title: const Text('Error'),
                              content:
                              Text('Failed to update Forma: $e'),
                              actions: [
                                TextButton(
                                  child: const Text('OK'),
                                  onPressed: () {
                                    Navigator.of(context).pop();
 },
                                  ),
                                ],
                              );
                            },
                          );
                        }
                      }
                    },
                  ),
                ],
              ),
            ),
          ),
       );
        }));
  }
}